﻿using Maticsoft.DBUtility;
using ZWGXPICK_SYS.Model;
using System;
using System.Data;
using System.Data.SQLite;
using System.Text;

namespace ZWGXZWGXPICK_SYS.DAL
{
    // 产品参数信息.
    public class PRODUCT_ITEM_CONFIG
    {
        // 添加一条新数据.
        public int Add(ZWGXPICK_SYS.Model.PRODUCT_ITEM_CONFIG model)
        {
            StringBuilder builder = new StringBuilder();
            builder.Append("insert into TB_PRODUCT_ITEM_CONFIG(");
            builder.Append("product_name,boat_dish_type,product_type,boat_dish_length,boat_dish_width,boat_slot_num,product_length,product_width,circular_boat_radius,central_hole_radius,matrix_type,place_type,x_direction_num,y_direction_num,is_rotation,standard_weight,qualified_allow_error,single_weight_allow_error,boat_first_point_x,boat_first_point_y,boat_dash_center_x,boat_dish_center_y)");
            builder.Append(" values (");
            builder.Append("@product_name,@boat_dish_type,@product_type,@boat_dish_length,@boat_dish_width,@boat_slot_num,@product_length,@product_width,@circular_boat_radius,@central_hole_radius,@matrix_type,@place_type,@x_direction_num,@y_direction_num,@is_rotation,@standard_weight,@qualified_allow_error,@single_weight_allow_error,@boat_first_point_x,@boat_first_point_y,@boat_dash_center_x,@boat_dish_center_y)");
            builder.Append(";select LAST_INSERT_ROWID()");
            SQLiteParameter[] cmdParms = new SQLiteParameter[]
            {
                new SQLiteParameter("@product_name",               DbType.String),
                new SQLiteParameter("@boat_dish_type",             DbType.Int32,4),
                new SQLiteParameter("@product_type",               DbType.Int32,4),
                new SQLiteParameter("@boat_dish_length",           DbType.Double,8),
                new SQLiteParameter("@boat_dish_width",            DbType.Double,8),
                new SQLiteParameter("@boat_slot_num",              DbType.Int32,4),
                new SQLiteParameter("@product_length",             DbType.Double,8),
                new SQLiteParameter("@product_width",              DbType.Double,8),
                new SQLiteParameter("@circular_boat_radius",       DbType.Double,8),
                new SQLiteParameter("@central_hole_radius",        DbType.Double,8),
                new SQLiteParameter("@matrix_type",                DbType.Int32,4),
                new SQLiteParameter("@place_type",                 DbType.Int32,4),
                new SQLiteParameter("@x_direction_num",            DbType.Int32,4),
                new SQLiteParameter("@y_direction_num",            DbType.Int32,4),
                new SQLiteParameter("@is_rotation",                DbType.Int32,4),
                new SQLiteParameter("@standard_weight",            DbType.Double,8),
                new SQLiteParameter("@qualified_allow_error",      DbType.Double,8),
                new SQLiteParameter("@single_weight_allow_error",  DbType.Double,8),
                new SQLiteParameter("@boat_first_point_x",         DbType.Double,8),
                new SQLiteParameter("@boat_first_point_y",         DbType.Double,8),
                new SQLiteParameter("@boat_dash_center_x",         DbType.Double,8),
                new SQLiteParameter("@boat_dish_center_y",         DbType.Double,8),
            };

            cmdParms[0].Value = model.product_name;
            cmdParms[1].Value = model.boat_dish_type;
            cmdParms[2].Value = model.product_type;
            cmdParms[3].Value = model.boat_dish_length;
            cmdParms[4].Value = model.boat_dish_width;
            cmdParms[5].Value = model.boat_slot_num;

            cmdParms[6].Value = model.product_length;
            cmdParms[7].Value = model.product_width;
            cmdParms[8].Value = model.circular_boat_radius;
            cmdParms[9].Value = model.central_hole_radius;
            cmdParms[10].Value = model.matrix_type;
            cmdParms[11].Value = model.place_type;
            cmdParms[12].Value = model.x_direction_num;
            cmdParms[13].Value = model.y_direction_num;
            cmdParms[14].Value = model.is_rotation;
            cmdParms[15].Value = model.standard_weight;
            cmdParms[16].Value = model.qualified_allow_error;
            cmdParms[17].Value = model.single_weight_allow_error;
            cmdParms[18].Value = model.boat_first_point_x;
            cmdParms[19].Value = model.boat_first_point_y;
            cmdParms[20].Value = model.boat_dash_center_x;
            cmdParms[21].Value = model.boat_dish_center_y;

            object single = DbHelperSQLite.GetSingle(builder.ToString(), cmdParms);
            if (single == null)
            {
                return 0;
            }
            return Convert.ToInt32(single);
        }

        // 根据指定的ID获取某一行数据.
        public ZWGXPICK_SYS.Model.PRODUCT_ITEM_CONFIG DataRowToModel(DataRow row)
        {
            ZWGXPICK_SYS.Model.PRODUCT_ITEM_CONFIG alarm_log = new ZWGXPICK_SYS.Model.PRODUCT_ITEM_CONFIG();
            if (row != null)
            {
                // model.id
                if ((row["id"] != null) && (row["ID"].ToString() != ""))
                {
                    alarm_log.id = Convert.ToInt32(row["ID"].ToString());
                }

                //model.product_name
                if ((row["product_name"] != null) && (row["product_name"].ToString() != ""))
                {
                    alarm_log.product_name = row["product_name"].ToString();
                }

                //model.boat_dish_type;
                if ((row["boat_dish_type"] != null) && (row["boat_dish_type"].ToString() != ""))
                {
                    alarm_log.boat_dish_type = Convert.ToInt32(row["boat_dish_type"].ToString());
                }
                //model.product_type;
                if ((row["product_type"] != null) && (row["product_type"].ToString() != ""))
                {
                    alarm_log.product_type = Convert.ToInt32(row["product_type"].ToString());
                }
                //model.boat_dish_length;
                if ((row["boat_dish_length"] != null) && (row["boat_dish_length"].ToString() != ""))
                {
                    alarm_log.boat_dish_length = Convert.ToDouble(row["boat_dish_length"].ToString());
                }
                //model.boat_dish_width;
                if ((row["boat_dish_width"] != null) && (row["boat_dish_width"].ToString() != ""))
                {
                    alarm_log.boat_dish_width = Convert.ToDouble(row["boat_dish_width"].ToString());
                }
                //model.boat_slot_num
                if ((row["boat_slot_num"] != null) && (row["boat_slot_num"].ToString() != ""))
                {
                    alarm_log.boat_slot_num = Convert.ToInt32(row["boat_slot_num"].ToString());
                }
                //model.product_length;
                if ((row["product_length"] != null) && (row["product_length"].ToString() != ""))
                {
                    alarm_log.product_length = Convert.ToDouble(row["product_length"].ToString());
                }
                //model.product_width;
                if ((row["product_width"] != null) && (row["product_width"].ToString() != ""))
                {
                    alarm_log.product_width = Convert.ToDouble(row["product_width"].ToString());
                }
                //model.circular_boat_radius;
                if ((row["circular_boat_radius"] != null) && (row["circular_boat_radius"].ToString() != ""))
                {
                    alarm_log.circular_boat_radius = Convert.ToDouble(row["circular_boat_radius"].ToString());
                }
                //model.central_hole_radius;
                if ((row["central_hole_radius"] != null) && (row["central_hole_radius"].ToString() != ""))
                {
                    alarm_log.central_hole_radius = Convert.ToDouble(row["central_hole_radius"].ToString());
                }
                //model.matrix_type;
                if ((row["matrix_type"] != null) && (row["matrix_type"].ToString() != ""))
                {
                    alarm_log.matrix_type = Convert.ToInt32(row["matrix_type"].ToString());
                }
                //model.place_type;
                if ((row["place_type"] != null) && (row["place_type"].ToString() != ""))
                {
                    alarm_log.place_type = Convert.ToInt32(row["place_type"].ToString());
                }
                //model.x_direction_num;
                if ((row["x_direction_num"] != null) && (row["x_direction_num"].ToString() != ""))
                {
                    alarm_log.x_direction_num = Convert.ToInt32(row["x_direction_num"].ToString());
                }
                //model.y_direction_num;
                if ((row["y_direction_num"] != null) && (row["y_direction_num"].ToString() != ""))
                {
                    alarm_log.y_direction_num = Convert.ToInt32(row["y_direction_num"].ToString());
                }
                //model.is_rotation;
                if ((row["is_rotation"] != null) && (row["is_rotation"].ToString() != ""))
                {
                    alarm_log.is_rotation = Convert.ToInt32(row["is_rotation"].ToString());
                }
                //model.standard_weight;
                if ((row["standard_weight"] != null) && (row["standard_weight"].ToString() != ""))
                {
                    alarm_log.standard_weight = Convert.ToDouble(row["standard_weight"].ToString());
                }
                //model.qualified_allow_error;
                if ((row["qualified_allow_error"] != null) && (row["qualified_allow_error"].ToString() != ""))
                {
                    alarm_log.qualified_allow_error = Convert.ToDouble(row["qualified_allow_error"].ToString());
                }
                //model.single_weight_allow_error;
                if ((row["single_weight_allow_error"] != null) && (row["single_weight_allow_error"].ToString() != ""))
                {
                    alarm_log.single_weight_allow_error = Convert.ToDouble(row["single_weight_allow_error"].ToString());
                }
                //model.boat_first_point_x;
                if ((row["boat_first_point_x"] != null) && (row["boat_first_point_x"].ToString() != ""))
                {
                    alarm_log.boat_first_point_x = Convert.ToDouble(row["boat_first_point_x"].ToString());
                }
                //model.boat_first_point_y;
                if ((row["boat_first_point_y"] != null) && (row["boat_first_point_y"].ToString() != ""))
                {
                    alarm_log.boat_first_point_y = Convert.ToDouble(row["boat_first_point_y"].ToString());
                }
                //model.boat_dash_center_x;
                if ((row["boat_dash_center_x"] != null) && (row["boat_dash_center_x"].ToString() != ""))
                {
                    alarm_log.boat_dash_center_x = Convert.ToDouble(row["boat_dash_center_x"].ToString());
                }
                //model.boat_dish_center_y;
                if ((row["boat_dish_center_y"] != null) && (row["boat_dish_center_y"].ToString() != ""))
                {
                    alarm_log.boat_dish_center_y = Convert.ToDouble(row["boat_dish_center_y"].ToString());
                }

                //model.status;
                if ((row["status"] != null) && (row["status"].ToString() != ""))
                {
                    alarm_log.status = Convert.ToInt32(row["status"].ToString());
                }

            }

            return alarm_log;
        }

        // 删除一行数据.
        public bool Delete(int id)
        {
            StringBuilder builder = new StringBuilder();
            builder.Append("delete from TB_PRODUCT_ITEM_CONFIG ");
            builder.Append(" where id=@id");
            SQLiteParameter[] cmdParms = new SQLiteParameter[] { new SQLiteParameter("@id", DbType.Int32, 4) };
            cmdParms[0].Value = id;
            return (DbHelperSQLite.ExecuteSql(builder.ToString(), cmdParms) > 0);
        }

        // 删除多行数据.
        public bool DeleteList(string IDlist)
        {
            StringBuilder builder = new StringBuilder();
            builder.Append("delete from TB_PRODUCT_ITEM_CONFIG ");
            builder.Append(" where id in (" + IDlist + ")  ");
            return (DbHelperSQLite.ExecuteSql(builder.ToString()) > 0);
        }

        // 数据是否存在.
        public bool Exists(int id)
        {
            StringBuilder builder = new StringBuilder();
            builder.Append("select count(1) from TB_PRODUCT_ITEM_CONFIG");
            builder.Append(" where id=@id");
            SQLiteParameter[] cmdParms = new SQLiteParameter[] { new SQLiteParameter("@id", DbType.Int32, 4) };
            cmdParms[0].Value = id;
            return DbHelperSQLite.Exists(builder.ToString(), cmdParms);
        }

        // 获取列表数据.
        public DataSet GetList(string strWhere)
        {
            StringBuilder builder = new StringBuilder();
            builder.Append("select id, product_name,boat_dish_type,product_type,boat_dish_length,boat_dish_width,boat_slot_num,product_length,product_width,circular_boat_radius,central_hole_radius,matrix_type,place_type,x_direction_num,y_direction_num,is_rotation,standard_weight,qualified_allow_error,single_weight_allow_error,boat_first_point_x,boat_first_point_y,boat_dash_center_x,boat_dish_center_y, status");
            builder.Append(" FROM TB_PRODUCT_ITEM_CONFIG ");
            if (strWhere.Trim() != "")
            {
                builder.Append(" where " + strWhere);
            }
            return DbHelperSQLite.Query(builder.ToString());
        }

        // 按分页获取列表数据.
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder builder = new StringBuilder();
            builder.Append("SELECT * FROM ( ");
            builder.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                builder.Append("order by T." + orderby);
            }
            else
            {
                builder.Append("order by T.ID desc");
            }

            builder.Append(")AS Row, T.*  from TB_PRODUCT_ITEM_CONFIG T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                builder.Append(" WHERE " + strWhere);
            }
            builder.Append(" ) TT");
            builder.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQLite.Query(builder.ToString());
        }

        // 获取最大ID.
        public int GetMaxId()
        {
            return DbHelperSQLite.GetMaxID("id", "TB_PRODUCT_ITEM_CONFIG");
        }

        // 根据ID获取一条数据.
        public ZWGXPICK_SYS.Model.PRODUCT_ITEM_CONFIG GetModel(int id)
        {
            StringBuilder builder = new StringBuilder();
            builder.Append("select id, product_name,boat_dish_type,product_type,boat_dish_length,boat_dish_width,boat_slot_num,product_length,product_width,circular_boat_radius,central_hole_radius,matrix_type,place_type,x_direction_num,y_direction_num,is_rotation,standard_weight,qualified_allow_error,single_weight_allow_error,boat_first_point_x,boat_first_point_y,boat_dash_center_x,boat_dish_center_y, status from TB_PRODUCT_ITEM_CONFIG ");
            builder.Append(" where id=@id");
            SQLiteParameter[] cmdParms = new SQLiteParameter[] { new SQLiteParameter("@id", DbType.Int32, 4) };
            cmdParms[0].Value = id;
            ZWGXPICK_SYS.Model.PRODUCT_ITEM_CONFIG alarm_log = new ZWGXPICK_SYS.Model.PRODUCT_ITEM_CONFIG();
            DataSet set = DbHelperSQLite.Query(builder.ToString(), cmdParms);
            if (set.Tables[0].Rows.Count > 0)
            {
                return this.DataRowToModel(set.Tables[0].Rows[0]);
            }
            return null;
        }

        // 根据条件查询数据总条数.
        public int GetRecordCount(string strWhere)
        {
            StringBuilder builder = new StringBuilder();
            builder.Append("select count(1) FROM TB_PRODUCT_ITEM_CONFIG ");
            if (strWhere.Trim() != "")
            {
                builder.Append(" where " + strWhere);
            }
            object single = DbHelperSQLite.GetSingle(builder.ToString());
            if (single == null)
            {
                return 0;
            }
            return Convert.ToInt32(single);
        }

        // 根据ID更新某一行数据.
        public bool Update(ZWGXPICK_SYS.Model.PRODUCT_ITEM_CONFIG model)
        {
            StringBuilder builder = new StringBuilder();
            builder.Append("update TB_PRODUCT_ITEM_CONFIG set ");

            builder.Append("product_name=@product_name,");
            builder.Append("boat_dish_type=@boat_dish_type,");
            builder.Append("product_type=@product_type,");
            builder.Append("boat_dish_length=@boat_dish_length,");
            builder.Append("boat_dish_width=@boat_dish_width,");
            builder.Append("boat_slot_num=@boat_slot_num,");

            builder.Append("product_length=@product_length,");
            builder.Append("product_width=@product_width,");
            builder.Append("circular_boat_radius=@circular_boat_radius,");
            builder.Append("central_hole_radius=@central_hole_radius,");
            builder.Append("matrix_type=@matrix_type,");
            builder.Append("place_type=@place_type,");
            builder.Append("x_direction_num=@x_direction_num,");
            builder.Append("y_direction_num=@y_direction_num,");
            builder.Append("is_rotation=@is_rotation,");
            builder.Append("standard_weight=@standard_weight,");
            builder.Append("qualified_allow_error=@qualified_allow_error,");
            builder.Append("single_weight_allow_error=@single_weight_allow_error,");
            builder.Append("boat_first_point_x=@boat_first_point_x,");
            builder.Append("boat_first_point_y=@boat_first_point_y,");
            builder.Append("boat_dash_center_x=@boat_dash_center_x,");
            builder.Append("boat_dish_center_y=@boat_dish_center_y,");
            builder.Append("status=@status");

            builder.Append(" where id=@id");
            SQLiteParameter[] cmdParms = new SQLiteParameter[]
            {
                new SQLiteParameter("@product_name",               DbType.String),
                new SQLiteParameter("@boat_dish_type",             DbType.Int32,4),
                new SQLiteParameter("@product_type",               DbType.Int32,4),
                new SQLiteParameter("@boat_dish_length",           DbType.Double,8),
                new SQLiteParameter("@boat_dish_width",            DbType.Double,8),
                new SQLiteParameter("@boat_slot_num",              DbType.Int32,4),

                new SQLiteParameter("@product_length",             DbType.Double,8),
                new SQLiteParameter("@product_width",              DbType.Double,8),
                new SQLiteParameter("@circular_boat_radius",       DbType.Double,8),
                new SQLiteParameter("@central_hole_radius",        DbType.Double,8),
                new SQLiteParameter("@matrix_type",                DbType.Int32,4),
                new SQLiteParameter("@place_type",                 DbType.Int32,4),
                new SQLiteParameter("@x_direction_num",            DbType.Int32,4),
                new SQLiteParameter("@y_direction_num",            DbType.Int32,4),
                new SQLiteParameter("@is_rotation",                DbType.Int32,4),
                new SQLiteParameter("@standard_weight",            DbType.Double,8),
                new SQLiteParameter("@qualified_allow_error",      DbType.Double,8),
                new SQLiteParameter("@single_weight_allow_error",  DbType.Double,8),
                new SQLiteParameter("@boat_first_point_x",         DbType.Double,8),
                new SQLiteParameter("@boat_first_point_y",         DbType.Double,8),
                new SQLiteParameter("@boat_dash_center_x",         DbType.Double,8),
                new SQLiteParameter("@boat_dish_center_y",         DbType.Double,8),
                new SQLiteParameter("@status",                     DbType.Int32,4),
                new SQLiteParameter("@id",                         DbType.Int32,4),
            };

            // 设置参数.
            cmdParms[0].Value = model.product_name;
            cmdParms[1].Value = model.boat_dish_type;
            cmdParms[2].Value = model.product_type;
            cmdParms[3].Value = model.boat_dish_length;
            cmdParms[4].Value = model.boat_dish_width;
            cmdParms[5].Value = model.boat_slot_num;

            cmdParms[6].Value = model.product_length;
            cmdParms[7].Value = model.product_width;
            cmdParms[8].Value = model.circular_boat_radius;
            cmdParms[9].Value = model.central_hole_radius;
            cmdParms[10].Value = model.matrix_type;
            cmdParms[11].Value = model.place_type;
            cmdParms[12].Value = model.x_direction_num;
            cmdParms[13].Value = model.y_direction_num;
            cmdParms[14].Value = model.is_rotation;
            cmdParms[15].Value = model.standard_weight;
            cmdParms[16].Value = model.qualified_allow_error;
            cmdParms[17].Value = model.single_weight_allow_error;
            cmdParms[18].Value = model.boat_first_point_x;
            cmdParms[19].Value = model.boat_first_point_y;
            cmdParms[20].Value = model.boat_dash_center_x;
            cmdParms[21].Value = model.boat_dish_center_y;

            cmdParms[22].Value = model.status;
            cmdParms[23].Value = model.id;
            return (DbHelperSQLite.ExecuteSql(builder.ToString(), cmdParms) > 0);
        }
    }
}

