﻿using Maticsoft.DBUtility;
using ZWGXPICK_SYS.Model;
using System;
using System.Data;
using System.Data.SQLite;
using System.Text;

namespace ZWGXZWGXPICK_SYS.DAL.SYS
{
    // 报警日志实现.
    public class SYS_USER
    {
        // 添加一条新数据.
        public int Add(ZWGXPICK_SYS.Model.SYS.SYS_USER model)
        {
            StringBuilder builder = new StringBuilder();
            builder.Append("insert into TB_SYS_USER(");
            builder.Append("uid,pwd,type)");
            builder.Append(" values (");
            builder.Append("@uid,@pwd,@type)");
            builder.Append(";select LAST_INSERT_ROWID()");
            SQLiteParameter[] cmdParms = new SQLiteParameter[]
            {
                new SQLiteParameter("@uid", DbType.String),
                new SQLiteParameter("@pwd", DbType.String),
                new SQLiteParameter("@type",DbType.Int32,4),
            };

            cmdParms[0].Value = model.uid;
            cmdParms[1].Value = model.pwd;
            cmdParms[2].Value = model.type;
            object single = DbHelperSQLite.GetSingle(builder.ToString(), cmdParms);
            if (single == null)
            {
                return 0;
            }
            return Convert.ToInt32(single);
        }

        // 根据指定的ID获取某一行数据.
        public ZWGXPICK_SYS.Model.SYS.SYS_USER DataRowToModel(DataRow row)
        {
            ZWGXPICK_SYS.Model.SYS.SYS_USER alarm_log = new ZWGXPICK_SYS.Model.SYS.SYS_USER();
            if (row != null)
            {
                // model.id
                if ((row["id"] != null) && (row["id"].ToString() != ""))
                {
                    alarm_log.id = int.Parse(row["id"].ToString());
                }

                //model.product_model
                if ((row["uid"] != null) && (row["uid"].ToString() != ""))
                {
                    alarm_log.uid= row["uid"].ToString();
                }

                //model.product_date;
                if ((row["pwd"] != null) && (row["pwd"].ToString() != ""))
                {
                    alarm_log.pwd = row["pwd"].ToString();
                }

                //model.product_time;
                if ((row["type"] != null) && (row["type"].ToString() != ""))
                {
                    alarm_log.type = int.Parse(row["type"].ToString());
                }
            }

            return alarm_log;
        }

        // 删除一行数据.
        public bool Delete(int id)
        {
            StringBuilder builder = new StringBuilder();
            builder.Append("delete from TB_SYS_USER ");
            builder.Append(" where id=@id");
            SQLiteParameter[] cmdParms = new SQLiteParameter[] { new SQLiteParameter("@id", DbType.Int32, 4) };
            cmdParms[0].Value = id;
            return (DbHelperSQLite.ExecuteSql(builder.ToString(), cmdParms) > 0);
        }

        // 删除多行数据.
        public bool DeleteList(string IDlist)
        {
            StringBuilder builder = new StringBuilder();
            builder.Append("delete from TB_SYS_USER ");
            builder.Append(" where id in (" + IDlist + ")  ");
            return (DbHelperSQLite.ExecuteSql(builder.ToString()) > 0);
        }

        // 数据是否存在.
        public bool Exists(int id)
        {
            StringBuilder builder = new StringBuilder();
            builder.Append("select count(1) from TB_SYS_USER");
            builder.Append(" where id=@id");
            SQLiteParameter[] cmdParms = new SQLiteParameter[] { new SQLiteParameter("@id", DbType.Int32, 4) };
            cmdParms[0].Value = id;
            return DbHelperSQLite.Exists(builder.ToString(), cmdParms);
        }

        // 获取列表数据.
        public DataSet GetList(string strWhere)
        {
            StringBuilder builder = new StringBuilder();
            builder.Append("select id,uid,pwd,type,status");
            builder.Append(" FROM TB_SYS_USER ");
            if (strWhere.Trim() != "")
            {
                builder.Append(" where " + strWhere);
            }
            return DbHelperSQLite.Query(builder.ToString());
        }

        // 按分页获取列表数据.
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder builder = new StringBuilder();
            builder.Append("SELECT * FROM ( ");
            builder.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                builder.Append("order by T." + orderby);
            }
            else
            {
                builder.Append("order by T.ID desc");
            }

            builder.Append(")AS Row, T.*  from TB_SYS_USER T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                builder.Append(" WHERE " + strWhere);
            }
            builder.Append(" ) TT");
            builder.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQLite.Query(builder.ToString());
        }

        // 获取最大ID.
        public int GetMaxId()
        {
            return DbHelperSQLite.GetMaxID("id", "TB_SYS_USER");
        }

        // 根据ID获取一条数据.
        public ZWGXPICK_SYS.Model.SYS.SYS_USER GetModel(int id)
        {
            StringBuilder builder = new StringBuilder();
            builder.Append("select id,uid,pwd,type,status from TB_SYS_USER ");
            builder.Append(" where id=@id");
            SQLiteParameter[] cmdParms = new SQLiteParameter[] { new SQLiteParameter("@id", DbType.Int32, 4) };
            cmdParms[0].Value = id;
            ZWGXPICK_SYS.Model.SYS.SYS_USER alarm_log = new ZWGXPICK_SYS.Model.SYS.SYS_USER();
            DataSet set = DbHelperSQLite.Query(builder.ToString(), cmdParms);
            if (set.Tables[0].Rows.Count > 0)
            {
                return this.DataRowToModel(set.Tables[0].Rows[0]);
            }
            return null;
        }

        // 根据条件查询数据总条数.
        public int GetRecordCount(string strWhere)
        {
            StringBuilder builder = new StringBuilder();
            builder.Append("select count(1) FROM TB_SYS_USER ");
            if (strWhere.Trim() != "")
            {
                builder.Append(" where " + strWhere);
            }
            object single = DbHelperSQLite.GetSingle(builder.ToString());
            if (single == null)
            {
                return 0;
            }
            return Convert.ToInt32(single);
        }

        // 根据ID更新某一行数据.
        public bool Update(ZWGXPICK_SYS.Model.SYS.SYS_USER model)
        {
            StringBuilder builder = new StringBuilder();
            builder.Append("update TB_SYS_USER set ");

            builder.Append("uid=@uid,");
            builder.Append("pwd=@pwd,");
            builder.Append("type=@type,");
            builder.Append("status=@status");

            builder.Append(" where id=@id");
            SQLiteParameter[] cmdParms = new SQLiteParameter[]
            {
                new SQLiteParameter("@uid",     DbType.String),
                new SQLiteParameter("@pwd",     DbType.String),
                new SQLiteParameter("@type",    DbType.Int32,4),
                new SQLiteParameter("@status",  DbType.Int32,4),
                new SQLiteParameter("@id",      DbType.Int32,4),
            };

            // 设置参数.
            cmdParms[0].Value = model.uid;
            cmdParms[1].Value = model.pwd;
            cmdParms[2].Value = model.type;
            cmdParms[3].Value = model.status;
            cmdParms[4].Value = model.id;
            return (DbHelperSQLite.ExecuteSql(builder.ToString(), cmdParms) > 0);
        }
    }
}

