﻿using Maticsoft.DBUtility;
using ZWGXPICK_SYS.Model;
using System;
using System.Data;
using System.Data.SQLite;
using System.Text;

namespace ZWGXPICK_SYS.DAL
{

    public class WEIGHT_LOG
    {
        // 添加一条新数据.
        public int Add(ZWGXPICK_SYS.Model.WEIGHT_LOG model)
        {
            StringBuilder builder = new StringBuilder();
            builder.Append("insert into TB_WEIGHT_LOG(");
            builder.Append("product_model,product_date,product_time,weight,is_qualified)");
            builder.Append(" values (");
            builder.Append("@product_model,@product_date,@product_time,@weight,@is_qualified)");
            builder.Append(";select LAST_INSERT_ROWID()");
            SQLiteParameter[] cmdParms = new SQLiteParameter[]
            {
                new SQLiteParameter("@product_model", DbType.String),
                new SQLiteParameter("@product_date",  DbType.String),
                new SQLiteParameter("@product_time",  DbType.String),
                new SQLiteParameter("@weight",        DbType.String),
                new SQLiteParameter("@is_qualified",  DbType.Int32, 4),
            };

            cmdParms[0].Value = model.product_model;
            cmdParms[1].Value = model.product_date;
            cmdParms[2].Value = model.product_time;
            cmdParms[3].Value = model.weight;
            cmdParms[4].Value = model.is_qualified;
            object single = DbHelperSQLite.GetSingle(builder.ToString(), cmdParms);
            if (single == null)
            {
                return 0;
            }
            return Convert.ToInt32(single);
        }

        // 根据指定的ID获取某一行数据.
        public ZWGXPICK_SYS.Model.WEIGHT_LOG DataRowToModel(DataRow row)
        {
            ZWGXPICK_SYS.Model.WEIGHT_LOG weight_log = new ZWGXPICK_SYS.Model.WEIGHT_LOG();
            if (row != null)
            {
                // model.id
                if ((row["id"] != null) && (row["ID"].ToString() != ""))
                {
                    weight_log.id = int.Parse(row["ID"].ToString());
                }

                //model.product_model
                if ((row["product_model"] != null) && (row["product_model"].ToString() != ""))
                {
                    weight_log.product_model = row["product_model"].ToString();
                }

                //model.product_date;
                if ((row["product_date"] != null) && (row["product_date"].ToString() != ""))
                {
                    weight_log.product_date = row["product_date"].ToString();
                }

                //model.product_time;
                if ((row["product_time"] != null) && (row["product_time"].ToString() != ""))
                {
                    weight_log.product_time = row["product_time"].ToString();
                }

                //model.weight;
                if ((row["weight"] != null) && (row["weight"].ToString() != ""))
                {
                    weight_log.weight = row["weight"].ToString();
                }

                //model.is_qualified;
                if ((row["is_qualified"] != null) && (row["is_qualified"].ToString() != ""))
                {
                    weight_log.is_qualified = int.Parse(row["is_qualified"].ToString());
                }
            }

            return weight_log;
        }

        // 删除一行数据.
        public bool Delete(int id)
        {
            StringBuilder builder = new StringBuilder();
            builder.Append("delete from TB_WEIGHT_LOG ");
            builder.Append(" where id=@id");
            SQLiteParameter[] cmdParms = new SQLiteParameter[] { new SQLiteParameter("@id", DbType.Int32, 4) };
            cmdParms[0].Value = id;
            return (DbHelperSQLite.ExecuteSql(builder.ToString(), cmdParms) > 0);
        }

        // 清空整个表数据.
        public bool DeleteAll()
        {
            StringBuilder builder = new StringBuilder();
            builder.Append("delete from TB_WEIGHT_LOG");
            return (DbHelperSQLite.ExecuteSql(builder.ToString()) > 0);
        }


        // 删除多行数据.
        public bool DeleteList(string IDlist)
        {
            StringBuilder builder = new StringBuilder();
            builder.Append("delete from TB_WEIGHT_LOG ");
            builder.Append(" where id in (" + IDlist + ")  ");
            return (DbHelperSQLite.ExecuteSql(builder.ToString()) > 0);
        }

        // 数据是否存在.
        public bool Exists(int id)
        {
            StringBuilder builder = new StringBuilder();
            builder.Append("select count(1) from TB_WEIGHT_LOG");
            builder.Append(" where id=@id");
            SQLiteParameter[] cmdParms = new SQLiteParameter[] { new SQLiteParameter("@id", DbType.Int32, 4) };
            cmdParms[0].Value = id;
            return DbHelperSQLite.Exists(builder.ToString(), cmdParms);
        }

        // 获取列表数据.
        public DataSet GetList(string strWhere)
        {
            StringBuilder builder = new StringBuilder();
            builder.Append("select id,product_model,product_date,product_time,weight,is_qualified ");
            builder.Append(" FROM TB_WEIGHT_LOG ");
            if (strWhere.Trim() != "")
            {
                builder.Append(" where " + strWhere);
            }
            return DbHelperSQLite.Query(builder.ToString());
        }

        // 按分页获取列表数据.
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder builder = new StringBuilder();
            builder.Append("SELECT * FROM ( ");
            builder.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                builder.Append("order by T." + orderby);
            }
            else
            {
                builder.Append("order by T.ID desc");
            }

            builder.Append(")AS Row, T.*  from TB_WEIGHT_LOG T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                builder.Append(" WHERE " + strWhere);
            }
            builder.Append(" ) TT");
            builder.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQLite.Query(builder.ToString());
        }

        // 获取最大ID.
        public int GetMaxId()
        {
            return DbHelperSQLite.GetMaxID("id", "TB_WEIGHT_LOG");
        }

        // 根据ID获取一条数据.
        public ZWGXPICK_SYS.Model.WEIGHT_LOG GetModel(int id)
        {
            StringBuilder builder = new StringBuilder();
            builder.Append("select id,product_model,product_date,product_time,weight,is_qualified from TB_WEIGHT_LOG ");
            builder.Append(" where id=@id");
            SQLiteParameter[] cmdParms = new SQLiteParameter[] { new SQLiteParameter("@id", DbType.Int32, 4) };
            cmdParms[0].Value = id;
            ZWGXPICK_SYS.Model.WEIGHT_LOG weight_log = new ZWGXPICK_SYS.Model.WEIGHT_LOG();
            DataSet set = DbHelperSQLite.Query(builder.ToString(), cmdParms);
            if (set.Tables[0].Rows.Count > 0)
            {
                return this.DataRowToModel(set.Tables[0].Rows[0]);
            }
            return null;
        }

        // 根据条件查询数据总条数.
        public int GetRecordCount(string strWhere)
        {
            StringBuilder builder = new StringBuilder();
            builder.Append("select count(1) FROM TB_WEIGHT_LOG ");
            if (strWhere.Trim() != "")
            {
                builder.Append(" where " + strWhere);
            }
            object single = DbHelperSQLite.GetSingle(builder.ToString());
            if (single == null)
            {
                return 0;
            }
            return Convert.ToInt32(single);
        }

        // 根据ID更新某一行数据.
        public bool Update(ZWGXPICK_SYS.Model.WEIGHT_LOG model)
        {
            StringBuilder builder = new StringBuilder();
            builder.Append("update TB_WEIGHT_LOG set ");
            builder.Append("product_model=@product_model,");
            builder.Append("product_date=@product_date,");
            builder.Append("product_time=@product_time,");
            builder.Append("weight=@weight,");
            builder.Append("is_qualified=@is_qualified");

            builder.Append(" where id=@id");
            SQLiteParameter[] cmdParms = new SQLiteParameter[]
            {
                new SQLiteParameter("@product_model", DbType.String),
                new SQLiteParameter("@product_date",  DbType.String),
                new SQLiteParameter("@product_time",  DbType.String),
                new SQLiteParameter("@weight",        DbType.String),
                new SQLiteParameter("@is_qualified",  DbType.Int32,4),
                new SQLiteParameter("@id",            DbType.Int32,4),
            };

            // 设置参数.
            cmdParms[0].Value = model.product_model;
            cmdParms[1].Value = model.product_date;
            cmdParms[2].Value = model.product_time;
            cmdParms[3].Value = model.weight;
            cmdParms[4].Value = model.is_qualified;
            cmdParms[5].Value = model.id;
            return (DbHelperSQLite.ExecuteSql(builder.ToString(), cmdParms) > 0);
        }
    }
}

