﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using ZWGXZWGXPICK_SYS.DAL;

namespace ZWGXPICK_SYS
{
    public partial class Alarm_Log_Form : Form
    {
        private float X;
        private float Y;
        public Alarm_Log_Form()
        {
            InitializeComponent();
        }

        private void setTag(Control cons)
        {
            foreach (Control con in cons.Controls)
            {
                con.Tag = con.Width + ":" + con.Height + ":" + con.Left + ":" + con.Top + ":" + con.Font.Size;
                if (con.Controls.Count > 0)
                    setTag(con);
            }
        }
        private void setControls(float newx, float newy, Control cons)
        {
            foreach (Control con in cons.Controls)
            {
                if (con.Tag == null) continue;
                string[] mytag = con.Tag.ToString().Split(new char[] { ':' });
                float a = Convert.ToSingle(mytag[0]) * newx;
                con.Width = (int)a;
                a = Convert.ToSingle(mytag[1]) * newy;
                con.Height = (int)(a);
                a = Convert.ToSingle(mytag[2]) * newx;
                con.Left = (int)(a);
                a = Convert.ToSingle(mytag[3]) * newy;
                con.Top = (int)(a);
                Single currentSize = Convert.ToSingle(mytag[4]) * Math.Min(newx, newy);
                con.Font = new Font(con.Font.Name, currentSize, con.Font.Style, con.Font.Unit);
                if (con.Controls.Count > 0)
                {
                    setControls(newx, newy, con);
                }
            }

        }

        void Form1_Resize(object sender, EventArgs e)
        {
            float newx = (this.Width) / X;
            float newy = this.Height / Y;
            setControls(newx, newy, this);
//             this.Text = this.Width.ToString() + " " + this.Height.ToString();

        }

        private void Alarm_Log_Form_Load(object sender, EventArgs e)
        {
            this.Resize += new EventHandler(Form1_Resize);

            X = this.Width;
            Y = this.Height;


            setTag(this);
            Form1_Resize(new object(), new EventArgs());//x,y可在实例化时赋值,最后这句是新加的，在MDI时有用
            this.CenterToScreen();

            // 刷新列表显示数据.
            updateListView();
        }

        private void updateListView()
        {
            // 显示所有日志数据.
            DataSet list = new ALARM_LOG().GetList("");
            DataTable dtfmt = list.Tables[0];

            // 去除掉不必要的列不显示.
            dtfmt.DefaultView.Sort = "id desc";
            dtfmt.Columns.Remove("id");
            dtfmt.Columns.Remove("status");
            dtfmt.Columns["log_date"].ColumnName = "日期";
            dtfmt.Columns["log_time"].ColumnName = "时间";
            dtfmt.Columns["log_classify"].ColumnName = "报警分类";
            dtfmt.Columns["log_content"].ColumnName = "报警内容";

            this.dataGridView1.DataSource = dtfmt;
            this.dataGridView1.DefaultCellStyle.ForeColor = Color.Red;
            this.dataGridView1.DefaultCellStyle.Font = new Font("Microsoft YaHei", 10, FontStyle.Bold);
            this.dataGridView1.ColumnHeadersDefaultCellStyle.Font = new Font("Microsoft YaHei", 10, FontStyle.Bold);
        }


        private void btnClear_Click(object sender, EventArgs e)
        {
            DialogResult dr = MessageBox.Show("您好,是否确认删除所有报警日志,清除后将不可恢复!?", "删除报警日志", MessageBoxButtons.YesNo);
            if (DialogResult.Yes == dr)
            {
                new ALARM_LOG().DeleteAll();
                updateListView();
            }
        }
    }
}
