﻿using EPSON_SOCKET;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ZWGXPICK_SYS
{
    public partial class Android_IO_Form : Form
    {
        private int curIndex = 0;
        private EPSON_SOCKET.EPSON_SOCKET epsonSocket1 = null;
        public Android_IO_Form(EPSON_SOCKET.EPSON_SOCKET epsonSocket)
        {
            InitializeComponent();
            this.epsonSocket1 = epsonSocket;
            this.epsonSocket1.rec_data_refresh += this.epsonSocket_rec_data_refresh;
        }

        // 窗口关闭保存参数.
        private void Android_IO_Form_FormClosing(object sender, FormClosingEventArgs e)
        {
            this.epsonSocket1.rec_data_refresh -= this.epsonSocket_rec_data_refresh;
        }

        private void Android_IO_Form_Load(object sender, EventArgs e)
        {
            this.CenterToScreen();
            btnrefresh_Click(sender,e);
        }

        private void btnrefresh_Click(object sender, EventArgs e)
        {
            this.progressBar1.Maximum = 24 + 24;
            this.progressBar1.Value = 0;
            this.progressBar1.Show();
            this.curIndex = 0;
            // 发送所有输入查询指令.
            string cmd = String.Format("$execute,\"print \"ri{0}=\", sw({0})\"",559);
            if (this.epsonSocket1.IsConnection)
                this.epsonSocket1.tcp_send(cmd);

            /*
            //发送所有输出查询指令.
            for (int i = 0; i < 16; i++)
            {
                string cmd = String.Format("$execute,\"print \"ro{0}=\", oport({0})\"", i);
                if (this.epsonSocket1.IsConnection)
                    this.epsonSocket1.tcp_send(cmd);

                System.Threading.Thread.Sleep(500);
                Application.DoEvents();
            }
            */
        }

        // 响应不同的点击命令.
        private void RO0_CheckedChanged(object sender, EventArgs e)
        {
        }

        private void RO0_Click(object sender, EventArgs e)
        {
            CheckBox obj = (CheckBox)sender;
            String ctrlName = obj.Name;
            ctrlName = ctrlName.Replace("RO", "");
            int nIndex = 0; int.TryParse(ctrlName, out nIndex);
            int nChecked = ((obj.Checked == true) ? 1 : 0);

            // 生成命令并发送.
            String cmd = String.Format("$setio,{0},{1}", nIndex, nChecked);
            if (this.epsonSocket1.IsConnection)
                this.epsonSocket1.tcp_send(cmd);

            // 更新控件显示颜色.
            obj.BackColor = Color.FromArgb(192, 192, 255);
            if (obj.Checked) obj.BackColor = Color.Red;

            // 自动刷新状态.
            btnrefresh_Click(sender, e);
        }

        // 接收到数据的响应函数.
        private void epsonSocket_rec_data_refresh(object sender, EventArgs e)
        {
            EventArgsCmd cmd = (EventArgsCmd)e;
            if (cmd == null) return;
            String str = cmd.Str;
            String[] result = str.Split(',');
            switch (cmd.Cmd)
            {
                case "execute":
                    {
                        if (str.IndexOf("execute,ri") >= 0)
                        {
                            System.Diagnostics.Debug.WriteLine( "RI:" + str);
                            String[] code = result[1].Split('=');
                            if (code.Length >= 2)
                            {
                                updateRIStatus(code[0], code[1]);
                            }

                            //String temp = code[1].Replace("RI", "");
                            //int nIndex = 0; int.TryParse(temp, out nIndex);
                            this.curIndex++;
                            this.progressBar1.Value++;
                            if (this.curIndex < 24)
                            {
                                string send = String.Format("$execute,\"print \"ri{0}=\", sw({0})\"", this.curIndex + 559);
                                if (this.epsonSocket1.IsConnection)
                                    this.epsonSocket1.tcp_send(send);
                            }
                            else
                            {
                                // 发送指令2
                                this.curIndex = 0;
                                string send = String.Format("$execute,\"print \"ro{0}=\", oport({0})\"", this.curIndex + 589);
                                if (this.epsonSocket1.IsConnection)
                                    this.epsonSocket1.tcp_send(send);

                            }

                        }
                        else if (str.IndexOf("execute,ro") >= 0)
                        {
                            System.Diagnostics.Debug.WriteLine("RO:" + str);
                            String[] code = result[1].Split('=');
                            if (code.Length >= 2)
                            {
                                updateROStatus(code[0], code[1]);
                            }
                            //String temp = code[1].Replace("RO", "");
                            //int nIndex = 0; int.TryParse(temp, out nIndex);

                            this.curIndex++;
                            this.progressBar1.Value++;
                            if (this.curIndex < 24)
                            {
                                // 发送指令2
                                string send = String.Format("$execute,\"print \"ro{0}=\", oport({0})\"", this.curIndex + 589);
                                if (this.epsonSocket1.IsConnection)
                                    this.epsonSocket1.tcp_send(send);
                            }
                            else
                            {
                                this.progressBar1.Hide();
                            }
                        }
                    }
                    break;
                default:
                    break;
            }
        }

        // 更新控件状态.
        private void updateRIStatus(string ctrlName,string sChecked)
        {
            Control[] controls = this.Controls.Find(ctrlName.ToUpper(), true);
            if ((controls == null) || (controls.Length <= 0))
            {
                return;
            }

            Label obj = (Label)controls[0];
            if (obj != null)
            {
                obj.Tag = sChecked;
                int nChecked = 0; int.TryParse(sChecked,out nChecked);
                obj.BackColor = Color.FromArgb(192, 192, 255);
                if (nChecked > 0) obj.BackColor = Color.Red;
            }
        }

        // 更新输出控件状态.
        private void updateROStatus(String ctrlName, string sChecked)
        {
            CheckBox obj = (CheckBox)this.Controls.Find(ctrlName.ToUpper(), true)[0];
            if (obj != null)
            {
                int nChecked = 0; int.TryParse(sChecked, out nChecked);
                obj.Checked = (nChecked > 0) ? true : false;
                obj.BackColor = Color.FromArgb(192, 192, 255);
                if (nChecked > 0) obj.BackColor = Color.Red;
            }
        }
    }
}
